/*
	This is part of CFugue, a C++ Runtime for MIDI Score Programming
	Copyright (C) 2009 Gopalakrishna Palem

	For links to further information, or to contact the author,
	see <http://cfugue.sourceforge.net/>.

	This file has been edited by the SickBeets team in order to make an executable that we can utilize when rendering MIDI files.
*/

// SampleApp.cpp
//
// Demonstrates the usage of CFugue as a Statically Linked Library
//
// CFugue is under active development.
// Please refer to documentation and latest releases at: http://cfugue.sourceforge.net/

#include "stdafx.h"
#include "stdlib.h"
#include <iostream>

#include "CFugueLib.h"

using namespace std;

void OnParseTrace(const CFugue::CParser*, CFugue::CParser::TraceEventHandlerArgs* pEvArgs)
{
     wcout << "\n\t" << pEvArgs->szTraceMsg;
}

void OnParseError(const CFugue::CParser*, CFugue::CParser::ErrorEventHandlerArgs* pEvArgs)
{
	wcerr << "\n\t Error --> " << pEvArgs->szErrMsg;
	if(pEvArgs->szToken)
	{
		wcerr << "\t Token: " << pEvArgs->szToken;
	}
}

int main(int argc, char* argv[])
{

  if (argc != 3)
  {
    exit(fprintf(stderr, "CFugue App Arguments: [String: notes] [String: output file name]"));
  }

  CFugue::Player player;
	player.SaveAsMidiFile(argv[1], argv[2]);

  string render_msg ("Rendered ");
  cout << render_msg + argv[1] << endl;

  return 0;

}

