# Sick Beets

### Sick Beets is a programming language that allows users to compose music by generating MIDI files. Sick Beets is inspired by the structured nature of music, which makes it easy to represent a composition piece by defining attributes of notes such as pitch or duration. Using Sick Beets, users can concatenate and layer series of notes to digitally encode their compositions.

## What is Sick Beets?
The language revolves around the idea of tunes, which are a series of notes attached to durations. Users can easily put together arrays of notes and durations to create a tune. In addition, users can concatenate tunes together as well as layer them on top of each other. Through a series of built in functions and operators, users are able to set the tempo, use different instruments, and layer their tunes together. Finally, users can render their tunes into MIDI files, which can be played to hear the final product.

## Running the Compiler and Executing a Program

1. Compile the CFugue Library (Make sure you delete the CFugueCache.txt file)
```shell
cd CFugue
cmake CMakeLists.txt
make
cd ..
```

2. Make the compiler
```shell
make
```

3. Compile the .sb file into llvm and run the llvm code
```shell
./sb.native < test.sb > test.ll
lli test.ll
```



